package com.heaton.forum;
import javax.servlet.jsp.*;
import javax.servlet.jsp.tagext.*;
import java.util.*;
import java.io.*;
import org.apache.taglibs.standard.tag.el.core.*;
import java.sql.*;

/**
 * Example program from Chapter 11
 * JSTL: JSP Standard Template Library
 * Published by Sams Publishing
 *
 *
 * This file implements the postMessages tag for the
 * forum custom tag library example.
 *
 * @author Jeff Heaton(http://www.jeffheaton.com)
 * @version 1.0
 */

public class PostMessageTag extends TagSupport {
  private String code_el;
  private String code;
  private String from_el;
  private String from;
  private String subject_el;
  private String subject;
  private String message_el;
  private String message;





  public void setCode(String code) {
    this.code_el = code;
  }

  public void setFrom(String from) {
    this.from_el = from;
  }

  public void setSubject(String subject) {
    this.subject_el = subject;
  }

  public void setMessage(String message) {
    this.message_el = message;
  }


  /**
   * The start of the tag, used to process the EL
   * expressions.
   * 
   * @return A status to indicate if the body is to be 
   * processed. Here the body is not processed.
   * @exception javax.servlet.jsp.JspException Thrown on general error.
   */
  public int doStartTag()
  throws  javax.servlet.jsp.JspException
  {
    code = (String)ExpressionUtil.evalNotNull(
      "postMessage", "code", code_el, String.class, this, pageContext);

    from = (String)ExpressionUtil.evalNotNull(
      "postMessage", "from", from_el, String.class, this, pageContext);

    subject = (String)ExpressionUtil.evalNotNull(
      "postMessage", "subject", subject_el, String.class, this, pageContext);

    message = (String)ExpressionUtil.evalNotNull(
      "postMessage", "message", message_el, String.class, this, pageContext);



    return SKIP_BODY;
  }

  /**
   * The ending tag method is called when the tag
   * is ready to complete. It is here that
   * the message is posted.
   * 
   * @return A status code that indicates if the rest of the
   * page is to be processed. 
   * @exception JspException Thrown on general error.
   */
  public int doEndTag() throws JspException {
    Session session = Session.getSession(pageContext);
    session.createMessage(code,from,subject,message);
    return EVAL_PAGE;
  }
}
